From e437b201925c9cf7d326498785be4847ec07f1cf Mon Sep 17 00:00:00 2001
From: Pravin B Shelar <pshelar@nicira.com>
Date: Tue, 21 May 2013 15:23:04 -0700
Subject: [PATCH] xfrm: Restore skb-cb after segmenting it.

Signed-off-by: Pravin B Shelar <pshelar@nicira.com>
---
 net/xfrm/xfrm_output.c |    7 +++++++
 1 files changed, 7 insertions(+), 0 deletions(-)

diff --git a/net/xfrm/xfrm_output.c b/net/xfrm/xfrm_output.c
index bcfda89..8c39951 100644
--- a/net/xfrm/xfrm_output.c
+++ b/net/xfrm/xfrm_output.c
@@ -152,7 +152,12 @@ static int xfrm_output2(struct sk_buff *skb)
 static int xfrm_output_gso(struct sk_buff *skb)
 {
 	struct sk_buff *segs;
+	struct inet_skb_parm cb;
 
+	/* GSO code make use of skb control block, save it locally,
+	 * so that we can restore it back to individual segments.
+	 **/
+	cb = *IPCB(skb);
 	segs = skb_gso_segment(skb, 0);
 	kfree_skb(skb);
 	if (IS_ERR(segs))
@@ -163,6 +168,8 @@ static int xfrm_output_gso(struct sk_buff *skb)
 		int err;
 
 		segs->next = NULL;
+		*IPCB(segs) = cb;
+
 		err = xfrm_output2(segs);
 
 		if (unlikely(err)) {
-- 
1.7.1

